/*
 * Copyright (c) 2003 David E. Bakken, his research students, and Washington State University.
 * Please see the file LICENSE.pdf for more details on terms of use.
 */

/*********************************************************
* HelloServer class
*---
* Simple test program that waits for the string "Hello" from the client and
* then sends the string "World" back.
*---
* @author David McKinnon
*********************************************************/

import java.net.*;
import java.io.*;

public class HelloServer {

    public static void main(String[] args) {
        ServerSocket socket;
        DataInputStream  sInput;
        DataOutputStream sOutput;

        try {
            socket  = new ServerSocket(12721);

            Socket client = socket.accept();
            sInput  = new DataInputStream(client.getInputStream());
            sOutput = new DataOutputStream(client.getOutputStream());

            String str = sInput.readUTF();
            System.out.println(str);

            sOutput.writeUTF("World");
        }
        catch (Exception e) {
            System.out.println(e);
        }
    }
}
