/*
 * Copyright (c) 2003 David E. Bakken, his research students, and Washington State University.
 * Please see the file LICENSE.pdf for more details on terms of use.
 */

package mqc.groupcom;
/**
 * This class implements a synchronized counter
 */
public class Counter
{

   private int counter;

   /** 
    *constructor for the counter object
    */
   public Counter()
   {
      // initialize the private data member to -1
      counter = -1;
   }

   /** 
    * method to return the counter value
    */
   public synchronized int getCounter()
   {
      return counter;
   }

   /** 
    * method to set and return the counter value
    */
   public synchronized int setCounter(int c)
   {
      counter = c;
      return counter;
   }

   /** 
    * method to increment and return the counter value
    */
   public synchronized int incCounter()
   {
      return(++counter);
   }

   /** 
    * method to increment and return the counter value
    *  as a string
    */
   public synchronized String incCounterS()
   {
      return(Integer.toString(++counter));
   }
}



