/*
 * Copyright (c) 2003 David E. Bakken, his research students, and Washington State University.
 * Please see the file LICENSE.pdf for more details on terms of use.
 */

/*
 * GroupComTester.java
 *
 * Created on June 7, 2002, 4:20 AM
 */

import javax.swing.*;
import java.util.*;
import java.net.*;

/**
 *
 * @author  Kevin Dorow
 */
public class GroupComTester extends javax.swing.JFrame implements MessageListener
{

   private GroupComUniform groupComUni;
   private GroupCom groupCom;
   private boolean blnLooper = false;
   private int intCounter = 0;

   /** Creates new form GroupComTester */
   public GroupComTester()
   {
      try
      {
         initComponents();
         jComboBox1.addItem("UDP");
         jComboBox1.addItem("TCP");
         jComboBox2.addItem("none");
         jComboBox2.addItem("fifo");
         jComboBox2.addItem("causal");
         jComboBox2.addItem("total");
         jCBUniform.addItem("no");
         jCBUniform.addItem("yes");
         InetAddress ina = InetAddress.getLocalHost();
         String strHostName = ina.getHostName();
         jTextField1.setText(strHostName);
         jTextField3.setText(strHostName + ":10000");
      }
      catch (Exception e)
      {
         e.printStackTrace();
      }
   }

   /** This method is called from within the constructor to
    * initialize the form.
    * WARNING: Do NOT modify this code. The content of this method is
    * always regenerated by the Form Editor.
    */
   private void initComponents()
   {//GEN-BEGIN:initComponents
      jPanel1 = new javax.swing.JPanel();
      jScrollPane1 = new javax.swing.JScrollPane();
      jTextArea1 = new javax.swing.JTextArea();
      jPanel2 = new javax.swing.JPanel();
      jPanel4 = new javax.swing.JPanel();
      jLabel1 = new javax.swing.JLabel();
      jTextField1 = new javax.swing.JTextField();
      jPanel5 = new javax.swing.JPanel();
      jLabel2 = new javax.swing.JLabel();
      jTextField2 = new javax.swing.JTextField();
      jPanel6 = new javax.swing.JPanel();
      jLabel3 = new javax.swing.JLabel();
      jComboBox1 = new javax.swing.JComboBox();
      jPanel7 = new javax.swing.JPanel();
      jLabel4 = new javax.swing.JLabel();
      jTextField3 = new javax.swing.JTextField();
      jPanel13 = new javax.swing.JPanel();
      jLabel7 = new javax.swing.JLabel();
      jComboBox2 = new javax.swing.JComboBox();
      jPanel14 = new javax.swing.JPanel();
      jLabel8 = new javax.swing.JLabel();
      jCBUniform = new javax.swing.JComboBox();
      jPanel8 = new javax.swing.JPanel();
      jButton1 = new javax.swing.JButton();
      jPanel9 = new javax.swing.JPanel();
      jLabel5 = new javax.swing.JLabel();
      jTextField4 = new javax.swing.JTextField();
      jPanel10 = new javax.swing.JPanel();
      jButton2 = new javax.swing.JButton();
      jPanel15 = new javax.swing.JPanel();
      jLabel9 = new javax.swing.JLabel();
      jTFDelay = new javax.swing.JTextField();
      jPanel16 = new javax.swing.JPanel();
      jButton4 = new javax.swing.JButton();
      jButton5 = new javax.swing.JButton();
      jPanel3 = new javax.swing.JPanel();
      jPanel11 = new javax.swing.JPanel();
      jLabel6 = new javax.swing.JLabel();
      jTextField5 = new javax.swing.JTextField();
      jPanel12 = new javax.swing.JPanel();
      jButton3 = new javax.swing.JButton();

      setTitle("Group Communication Tester");
      addWindowListener(new java.awt.event.WindowAdapter()
                        {
                           public void windowClosing(java.awt.event.WindowEvent evt)
                           {
                              exitForm(evt);
                           }
                        }
                       );

      jPanel1.setLayout(new java.awt.BorderLayout());

      jScrollPane1.setViewportView(jTextArea1);

      jPanel1.add(jScrollPane1, java.awt.BorderLayout.CENTER);

      getContentPane().add(jPanel1, java.awt.BorderLayout.CENTER);

      jPanel2.setLayout(new java.awt.GridLayout(11, 1));

      jPanel4.setLayout(new java.awt.GridLayout(1, 2));

      jLabel1.setText("Server Name:");
      jPanel4.add(jLabel1);

      jPanel4.add(jTextField1);

      jPanel2.add(jPanel4);

      jPanel5.setLayout(new java.awt.GridLayout(1, 2));

      jLabel2.setText("Listening Port:");
      jPanel5.add(jLabel2);

      jTextField2.setText("10000");
      jPanel5.add(jTextField2);

      jPanel2.add(jPanel5);

      jPanel6.setLayout(new java.awt.GridLayout(1, 0));

      jLabel3.setText("Transport:");
      jPanel6.add(jLabel3);

      jPanel6.add(jComboBox1);

      jPanel2.add(jPanel6);

      jPanel7.setLayout(new java.awt.GridLayout(1, 0));

      jLabel4.setText("Group List:");
      jPanel7.add(jLabel4);

      jPanel7.add(jTextField3);

      jPanel2.add(jPanel7);

      jPanel13.setLayout(new java.awt.GridLayout(1, 2));

      jLabel7.setText("Ordering:");
      jPanel13.add(jLabel7);

      jPanel13.add(jComboBox2);

      jPanel2.add(jPanel13);

      jPanel14.setLayout(new java.awt.GridLayout(1, 2));

      jLabel8.setText("Uniform:");
      jPanel14.add(jLabel8);

      jPanel14.add(jCBUniform);

      jPanel2.add(jPanel14);

      jButton1.setText("Start Listener");
      jButton1.addActionListener(new java.awt.event.ActionListener()
                                 {
                                    public void actionPerformed(java.awt.event.ActionEvent evt)
                                    {
                                       jButton1ActionPerformed(evt);
                                    }
                                 }
                                );

      jPanel8.add(jButton1);

      jPanel2.add(jPanel8);

      jPanel9.setLayout(new java.awt.GridLayout(1, 0));

      jLabel5.setText("Message Data:");
      jPanel9.add(jLabel5);

      jPanel9.add(jTextField4);

      jPanel2.add(jPanel9);

      jButton2.setText("Send Message");
      jButton2.addActionListener(new java.awt.event.ActionListener()
                                 {
                                    public void actionPerformed(java.awt.event.ActionEvent evt)
                                    {
                                       jButton2ActionPerformed(evt);
                                    }
                                 }
                                );

      jPanel10.add(jButton2);

      jPanel2.add(jPanel10);

      jPanel15.setLayout(new java.awt.GridLayout(1, 2));

      jLabel9.setText("Message Delay:");
      jPanel15.add(jLabel9);

      jPanel15.add(jTFDelay);

      jPanel2.add(jPanel15);

      jButton4.setText("Continuous Send");
      jButton4.addActionListener(new java.awt.event.ActionListener()
                                 {
                                    public void actionPerformed(java.awt.event.ActionEvent evt)
                                    {
                                       jButton4ActionPerformed(evt);
                                    }
                                 }
                                );

      jPanel16.add(jButton4);

      jButton5.setText("Buffer");
      jButton5.addActionListener(new java.awt.event.ActionListener()
                                 {
                                    public void actionPerformed(java.awt.event.ActionEvent evt)
                                    {
                                       jButton5ActionPerformed(evt);
                                    }
                                 }
                                );

      jPanel16.add(jButton5);

      jPanel2.add(jPanel16);

      getContentPane().add(jPanel2, java.awt.BorderLayout.NORTH);

      jPanel3.setLayout(new java.awt.GridLayout(2, 1));

      jPanel11.setLayout(new java.awt.GridLayout(1, 0));

      jLabel6.setText("Group Member Info:");
      jPanel11.add(jLabel6);

      jPanel11.add(jTextField5);

      jPanel3.add(jPanel11);

      jButton3.setText("Join Group");
      jButton3.addActionListener(new java.awt.event.ActionListener()
                                 {
                                    public void actionPerformed(java.awt.event.ActionEvent evt)
                                    {
                                       jButton3ActionPerformed(evt);
                                    }
                                 }
                                );

      jPanel12.add(jButton3);

      jPanel3.add(jPanel12);

      getContentPane().add(jPanel3, java.awt.BorderLayout.SOUTH);

      pack();
   }//GEN-END:initComponents

   private void jButton5ActionPerformed(java.awt.event.ActionEvent evt)
   {//GEN-FIRST:event_jButton5ActionPerformed
      // return the Total Ordering buffer to view
      String strUniform = (String) jCBUniform.getSelectedItem();
      Vector vBuffer = new Vector();
      if(strUniform.equalsIgnoreCase("no"))
      {
         vBuffer = groupCom.returnBuffer();
      }
      else
      {
         vBuffer = groupComUni.returnBuffer();
      }
      String strOrdering = (String) jComboBox2.getSelectedItem();
      if(strOrdering.equalsIgnoreCase("total"))
      {
         if(strUniform.equalsIgnoreCase("no"))
         {
            groupCom.printTMBuffer();
            groupCom.printTSBuffer();
         }
         else
         {
            groupComUni.printTMBuffer();
            groupComUni.printTSBuffer();
         }
      }
      else if(strOrdering.equalsIgnoreCase("causal"))
      {
         // set up a loop to print out the contents of the buffer
         for(int i=0;i<vBuffer.size();i++)
         {
            // grab the vector element from the buffer
            Vector vCurElem = (Vector) vBuffer.elementAt(i);
            // extract the fields from the vector
            String strSender = (String) vCurElem.elementAt(0);
            String strMessageID = (String) vCurElem.elementAt(1);
            MessageEvent me = (MessageEvent) vCurElem.elementAt(2);
            String strDeliver = (String) vCurElem.elementAt(3);
            Vector vMessageData = me.getMessageData();
            String strMessageData = (String) vMessageData.elementAt(3);
            System.out.println(strSender + "-" + strMessageID + "-" + strDeliver + "-" + strMessageData);
         }
      }
      if(strUniform.equalsIgnoreCase("no"))
      {
         // here we can also get the status buffer (sent messages)
         Vector vStatus = groupCom.returnSBuffer();
         System.out.println("The size of the status buffer is: " + vStatus.size());
         // here we can also get the message buffer (received messages)
         Vector vMessage = groupCom.returnMBuffer();
         System.out.println("The size of the message buffer is: " + vMessage.size());
      }
      else
      {
         // here we can also get the status buffer (sent messages)
         Vector vStatus = groupComUni.returnSBuffer();
         System.out.println("The size of the status buffer is: " + vStatus.size());
         // here we can also get the message buffer (received messages)
         Vector vMessage = groupComUni.returnMBuffer();
         System.out.println("The size of the message buffer is: " + vMessage.size());
      }
   }//GEN-LAST:event_jButton5ActionPerformed

   private void jButton4ActionPerformed(java.awt.event.ActionEvent evt)
   {//GEN-FIRST:event_jButton4ActionPerformed
      // get the contact member info
      if(blnLooper == false)
      {
         blnLooper = true;
         ContinuousSend cs = new ContinuousSend();
         Thread tCS = new Thread(cs);
         tCS.start();
      }
      else
      {
         blnLooper = false;
      }
   }//GEN-LAST:event_jButton4ActionPerformed

   private void jButton3ActionPerformed(java.awt.event.ActionEvent evt)
   {//GEN-FIRST:event_jButton3ActionPerformed
      // get the contact member info
      String strContactMember = jTextField5.getText();
      String strUniform = (String) jCBUniform.getSelectedItem();
      if(strUniform.equalsIgnoreCase("no"))
      {
         groupCom.joinGroup(strContactMember);
      }
      else
      {
         groupComUni.joinGroup(strContactMember);
      }
   }//GEN-LAST:event_jButton3ActionPerformed

   private void jButton2ActionPerformed(java.awt.event.ActionEvent evt)
   {//GEN-FIRST:event_jButton2ActionPerformed
      // send a message to the group
      String strMessage = jTextField4.getText();
      String strUniform = (String) jCBUniform.getSelectedItem();
      if(strUniform.equalsIgnoreCase("no"))
      {
         groupCom.sendMessage(strMessage,"message","","");
      }
      else
      {
         groupComUni.sendMessage(strMessage,"message","","");
      }
   }//GEN-LAST:event_jButton2ActionPerformed

   private void jButton1ActionPerformed(java.awt.event.ActionEvent evt)
   {//GEN-FIRST:event_jButton1ActionPerformed
      if(groupCom == null)
      {
         // get the information from the GUI and instanciate the groupcom object
         String strServer = jTextField1.getText();
         String strTemp = jTextField2.getText();
         int intListenPort = Integer.parseInt(strTemp);
         String strGroupList = jTextField3.getText();
         String strTransport = (String) jComboBox1.getSelectedItem();
         String strOrdering = (String) jComboBox2.getSelectedItem();
         String strUniform = (String) jCBUniform.getSelectedItem();
         // check to see if we need to be use uniform or non-uniform communication
         if(strUniform.equalsIgnoreCase("no"))
         {
            //groupCom = new GroupComUniform(intListenPort,strGroupList,strServer,strTransport,strOrdering);
            groupCom = new GroupCom(intListenPort,strGroupList,strServer,strTransport,strOrdering);
            // register for events
            groupCom.addMessageListener(this);
            // start the listener
            groupCom.startListener();
         }
         else
         {
            groupComUni = new GroupComUniform(intListenPort,strGroupList,strServer,strTransport,strOrdering);
            //groupCom = new GroupCom(intListenPort,strGroupList,strServer,strTransport,strOrdering);
            // register for events
            groupComUni.addMessageListener(this);
            // start the listener
            groupComUni.startListener();
         }
         // disable the controls on the GUI
         jTextField1.setEnabled(false);
         jTextField2.setEnabled(false);
         jTextField3.setEnabled(false);
         jComboBox1.setEnabled(false);
         jButton1.setEnabled(false);
      }
   }//GEN-LAST:event_jButton1ActionPerformed

   /** Exit the Application */
   private void exitForm(java.awt.event.WindowEvent evt)
   {//GEN-FIRST:event_exitForm
      System.exit(0);
   }//GEN-LAST:event_exitForm

   /**
    * @param args the command line arguments
    */
   public static void main(String args[])
   {
      new GroupComTester().show();
   }

   /** define a method that is called whenever a MessageEvent takes place
    */
   public void receiveMessage(MessageEvent me)
   {
      // first grab a timestamp
      long lngCurTime = System.currentTimeMillis();
      // first we need to extract the vector containing the information about
      //  the message
      Vector vMessageInfo = me.getMessageData();
      // extract the message data from the vector
      String strSender = (String) vMessageInfo.elementAt(0);
      String strGroupList = (String) vMessageInfo.elementAt(1);
      String strMessageID = (String) vMessageInfo.elementAt(2);
      String strMessageData = (String) vMessageInfo.elementAt(3);
      String strTemp = (String) vMessageInfo.elementAt(4);
      long lngSendTime = Long.parseLong(strTemp);
      // build the string to display the message
      String strMessage = "A message was received from: " + strSender + "\n" +
                          "The message was: " + strMessageData + "\n" +
                          "The Group List was: " + strGroupList + "\n" +
                          "The message id was: " + strMessageID;
      // now create a dialog box
      //JOptionPane.showMessageDialog(this,strMessage,"Message received",JOptionPane.INFORMATION_MESSAGE);
      //jTextArea1.setText(jTextArea1.getText() + "\n\n" + strMessage);
      jTextArea1.setText(strMessage);
   }

   // Variables declaration - do not modify//GEN-BEGIN:variables
   private javax.swing.JPanel jPanel9;
   private javax.swing.JPanel jPanel8;
   private javax.swing.JPanel jPanel7;
   private javax.swing.JPanel jPanel6;
   private javax.swing.JPanel jPanel5;
   private javax.swing.JPanel jPanel4;
   private javax.swing.JButton jButton5;
   private javax.swing.JPanel jPanel3;
   private javax.swing.JButton jButton4;
   private javax.swing.JPanel jPanel2;
   private javax.swing.JButton jButton3;
   private javax.swing.JPanel jPanel1;
   private javax.swing.JButton jButton2;
   private javax.swing.JButton jButton1;
   private javax.swing.JScrollPane jScrollPane1;
   private javax.swing.JComboBox jCBUniform;
   private javax.swing.JComboBox jComboBox2;
   private javax.swing.JComboBox jComboBox1;
   private javax.swing.JPanel jPanel16;
   private javax.swing.JPanel jPanel15;
   private javax.swing.JPanel jPanel14;
   private javax.swing.JPanel jPanel13;
   private javax.swing.JPanel jPanel12;
   private javax.swing.JPanel jPanel11;
   private javax.swing.JPanel jPanel10;
   private javax.swing.JTextField jTextField5;
   private javax.swing.JTextField jTextField4;
   private javax.swing.JTextField jTextField3;
   private javax.swing.JLabel jLabel9;
   private javax.swing.JTextField jTextField2;
   private javax.swing.JLabel jLabel8;
   private javax.swing.JTextField jTextField1;
   private javax.swing.JLabel jLabel7;
   private javax.swing.JTextArea jTextArea1;
   private javax.swing.JLabel jLabel6;
   private javax.swing.JLabel jLabel5;
   private javax.swing.JLabel jLabel4;
   private javax.swing.JLabel jLabel3;
   private javax.swing.JLabel jLabel2;
   private javax.swing.JTextField jTFDelay;
   private javax.swing.JLabel jLabel1;
   // End of variables declaration//GEN-END:variables

   class ContinuousSend implements Runnable
   {

      public void run()
      {
         String strMessage = jTextField4.getText();
         String strUniform = (String) jCBUniform.getSelectedItem();
         String strDelay = jTFDelay.getText();
         int intDelay = Integer.parseInt(strDelay);
         while(blnLooper == true)
         {
            if(strUniform.equalsIgnoreCase("no"))
            {
               groupCom.sendMessage(strMessage + "-" + Integer.toString(intCounter++),"message","","");
            }
            else
            {
               groupComUni.sendMessage(strMessage + "-" + Integer.toString(intCounter++),"message","","");
            }
            try
            {
               Thread.sleep(intDelay);
            }
            catch (Exception e)
            {
               e.printStackTrace();
            }
         }
      }
   }
}
