/*
 * Copyright (c) 2003 David E. Bakken, his research students, and Washington State University.
 * Please see the file LICENSE.pdf for more details on terms of use.
 */

package mqc.groupcom;
/*
 * MessageEvent.java
 *
 * Created on June 6, 2002, 3:48 AM
 */

import java.util.EventObject;
import java.util.*;

/**
 *
 * @author  Kevin Dorow
 */
public class MessageEvent extends EventObject
{
   // this class is an event that represents a message that gets sent to the group

   // define a vector that will hold the message info
   private Vector vMessageInfo;

   // define the constructor
   public MessageEvent(Object source, String strSender, String strGroupList, String strMessageID, String strMessageData)
   {
      // call the constructor for the super class, passing the source of the event
      super(source);
      // initialize the vector
      this.vMessageInfo = new Vector();
      // add the message data to the vector
      this.vMessageInfo.addElement(strSender);
      this.vMessageInfo.addElement(strGroupList);
      this.vMessageInfo.addElement(strMessageID);
      this.vMessageInfo.addElement(strMessageData);
      // also add in the current time (for timing analysis)
      String strCurTime = Long.toString(System.currentTimeMillis());
      this.vMessageInfo.addElement(strCurTime);
   }

   // define a method to return the vector
   public Vector getMessageData()
   {
      return vMessageInfo;
   }
}




