/*
 * Copyright (c) 2003 David E. Bakken, his research students, and Washington State University.
 * Please see the file LICENSE.pdf for more details on terms of use.
 */

include(`Config_macros.m4')

package mqc.ior;

import java.util.Hashtable;
import java.util.Enumeration;

/**
* A profile for communication with the server.
* Contains all neccessary information for a client to 
* contact a server.
*
* @author Olav Haugan
* @author David McKinnon
*/
public class Profile
{
   /* Profile members */
   public String typeID;
   public Hashtable taggedProfile;

   /**
   * Constructor. Initializes variables
   */
   public Profile()
   {
      __J2SE__(
      taggedProfile = new Hashtable(1,1);
      )
      __CLDC__(
      //CLDC does not support Hashtable(capacity,loadFactor)
      taggedProfile = new Hashtable(1);
      )
      typeID = null;
   }

   /**
   * Adds a tagged profile to the list of profiles
   *
   * @param TaggedProfile The tagged profile object.
   */
   public void add(TaggedProfile taggedProfile)
   {
      this.taggedProfile.put(new Integer(taggedProfile.profileTag), taggedProfile);
   }

   /**
    * gets an enumerated list of profile(s)
    */
   public Enumeration getProfiles()
   {
      return taggedProfile.elements();
   }

   /**
   * Gets the tagged profile requested
   *
   * @param int profile tag requested
   * @return TaggedProfile The tagged profile object.
   */
   public TaggedProfile getTaggedProfile(int tag)
   {
      return (TaggedProfile) taggedProfile.get(new Integer(tag));
   }

}

