/*
 * Copyright (c) 2003 David E. Bakken, his research students, and Washington State University.
 * Please see the file LICENSE.pdf for more details on terms of use.
 */

package mqc.protocols;

import mqc.holders.IntHolder;

public class Body
{
   protected byte[] m_buffer;
   protected int m_ptr;
   protected int m_completionStatus;
   protected int m_exceptionMinor;
   protected int m_vmcid;
   protected String m_exceptionID;

   public Body()
   {
      m_ptr = 0;
      m_buffer = new byte[0];
   }

   public byte[] getBuffer()
   {
      return m_buffer;
   }

   public void setBuffer( byte[] buf )
   {
      m_buffer = buf;
   }

   public int getPtr()
   {
      return m_ptr;
   }

   public void setPtr( int ptr )
   {
      m_ptr = ptr;
   }

   public void setMinSize( int size )
   {
      if ( m_buffer ==  null )
      {
         m_buffer = new byte[ size ];
      }
      else if ( m_buffer.length < size )
      {
         byte[] tmp = new byte[size];
         System.arraycopy( m_buffer, 0, tmp, 0, m_buffer.length );
         m_buffer = tmp;
      }
   }

   public int getCompletionStatus()
   {
      return m_completionStatus;
   }

   public void setCompletionStatus( int status )
   {
      m_completionStatus = status;
   }

   public int getExceptionMinorCode()
   {
      return m_exceptionMinor;
   }

   public void setExceptionMinorCode( int minor )
   {
      m_exceptionMinor = minor;
   }

   public int getExceptionMinorVMCID()
   {
      return m_vmcid;
   }

   public void setExceptionMinorVMCID( int vmcid )
   {
      m_vmcid = vmcid;
   }

   public String getExceptionID()
   {
      return m_exceptionID;
   }

   public void setExceptionID( String id )
   {
      m_exceptionID = id;
   }

}
