/*
 * Copyright (c) 2003 David E. Bakken, his research students, and Washington State University.
 * Please see the file LICENSE.pdf for more details on terms of use.
 */

package mqc.protocols;

/**
 * @author Kim Christian Swenson
 */
public class GIOPHeader_1_2 extends GIOPHeader_1_1
{
   public GIOPHeader_1_2()
   {
      super();

      //Reinitialize minor
      m_minor = 2;
   }

   public void deMarshal( CDRInputStream in ) throws RuntimeException
   {
      super.deMarshal( in );

      // Check whether second least significant bit in flags is set
      if ( (m_flags & 0x02) == 0x02 )
      {
         if ( (m_msgSize + 12) % 8 != 0 )
         {
            throw new RuntimeException("GIOP message size including header not evenly divisible by 8.");
         }
      }
   }
}
